﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Mob : MonoBehaviour
{
    public Enumerators.Mob_Types        MobType     { get; set; }
    public Enumerators.Screen_Types     ScreenType  { get; set; }

    public float                        MobSpeed
    {
        get
        {
            return GameManager.Singleton.Current_ScreenConfiguration[(int)ScreenType].MobSpeed;
        }
    }
    public GameObject                   Target
    {
        get
        {
            return GameManager.Singleton.GetPlayer(ScreenType);
        }
    }

    public void SetMobConfig(Enumerators.Mob_Types mobType, Enumerators.Screen_Types screenType)
    {
        MobType         = mobType;
        ScreenType      = screenType;
    }

    // Use this for initialization
    void Start ()
    {
		
	}
	
	// Update is called once per frame
	void Update ()
    {
        transform.LookAt(Target.transform);
        
        transform.position += transform.forward * MobSpeed * Time.smoothDeltaTime;
    }
}
