﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ScreenCFG
{
    /// <summary>
    /// Vision radius of the game area
    /// </summary>
    public float                    VisionRadius         { get; set; }
    /// <summary>
    /// Total number of mob kills on the game area
    /// </summary>
    public int                      MobKillCount        { get; set; }
    /// <summary>
    /// Queue of mobs spawns for the game area
    /// </summary>
    public Queue<MobSpawnInfo>      SpawnQueue          { get; set; }
    /// <summary>
    /// this variable sets the speed of the mobs on the game area
    /// </summary>
    public float                    MobSpeed            { get; set; }
    /// <summary>
    /// this variable sets the mob spawn rate on the game area
    /// </summary>
    public float                    SpawnRate           { get; set; }

    public float                    LastSpawnTime       { get; set; }
    public float                    NextSpawnTime
    {
        get { return this.LastSpawnTime + this.SpawnRate; }
    }

    /// <summary>
    /// Sets the Game Area as Dead
    /// </summary>
    public bool                     ScreenDead          { get; set; }
    

    public ScreenCFG(float visionRadius, float mobSpeed, float spawnRate)
    {
        this.VisionRadius       = visionRadius;
        this.MobKillCount       = 0;
        this.SpawnQueue         = new Queue<MobSpawnInfo>();
        this.MobSpeed           = mobSpeed;
        this.SpawnRate          = spawnRate;
        this.ScreenDead         = false;
    }
}
