﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Player1 : MonoBehaviour {

    public float playerspeed;
    private float movex = 0f;
    private float movez = 0f;
    private float turnx = 0f;
    private float turnz = 0f;

    public Transform nose;
    public GameObject projectile;

    public float shootForce = 0f;
    private bool block;

    public bool IsPlayerDead { get; set; }

    // Use this for initialization
    void Start()
    {
        playerspeed = GameManager.Singleton.CFG_Default_PlayerSpeed;
    }

    // Update is called once per frame
    void Update()
    {
        if (IsPlayerDead)
            return;

        Shoot();

        movez = Input.GetAxis("Vertical1") * playerspeed;
        movex = Input.GetAxis("Horizontal1") * playerspeed;

        GetComponent<Rigidbody>().velocity = new Vector3(movex, 0, movez);



        turnx = Input.GetAxis("Right_analog_x1");
        turnz = Input.GetAxis("Right_analog_z1");

        float aim_angle = 0.0f;       
       
        // CANCEL ALL INPUT BELOW THIS FLOAT
        float R_analog_threshold = 0.2f;

        if (Mathf.Abs(turnx) < R_analog_threshold) { turnx = 0.0f; }

        if (Mathf.Abs(turnz) < R_analog_threshold) { turnz = 0.0f; }

        // CALCULATE ANGLE AND ROTATE
        if (turnx != 0.0f || turnz != 0.0f)
        {

            aim_angle = Mathf.Atan2(turnx, turnz) * Mathf.Rad2Deg;

            // ANGLE GUN
            transform.rotation = Quaternion.AngleAxis(aim_angle, Vector3.down);
        }

        if (Input.GetButtonDown("Right_bumper"))
        {

        }
    }

    void Shoot()
    {
        if (IsPlayerDead)
            return;

        if (Mathf.Round(Input.GetAxisRaw("R21")) < 0 && block == false)
        {
          
                block = true;
                GameObject Projectile = (GameObject)Instantiate(projectile, nose.position, nose.rotation);
                Projectile.GetComponent<Rigidbody>().AddForce(nose.forward * shootForce);
                Invoke("UnBlock", 0.3f);
            
        }
        
    }


    void UnBlock()
    {
        block = false;      
    }

    void OnTriggerEnter(Collider other)
    {        
        if (other.gameObject.tag == "Enemy")
        {
            IsPlayerDead = true;
            GameManager.Singleton.PlayerDeath(gameObject);
        }
    }
}
